/* Converts Kfir microcode to include files.
   I first had this in the kernel driver (thats why the kfir struct is used)
   but this caused crashes and/or strange kernel behavior. I removed the normal
   mistakes (too large stack allocation for kernel, etc.) but this did not help ...
   
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

#define false 0
#define TRUE 1
typedef unsigned int DWORD;
typedef unsigned int u32;
typedef signed char s8;
typedef int bool;

const char KF_MIC_DELIMETER = '#';

struct kfir_dev {
  unsigned char *micro, *microp;
  int microlen;
};

int Kfir_LoadMicroCode(struct kfir_dev *kfir, 
		       DWORD * const ptMicroCodeLength, 
		       DWORD * const ptMicroCode)
{
	int i = kfir->microp - kfir->micro;
	s8 *micro=(s8 *) kfir->micro;
	bool Flag;
	int j = 0;
	DWORD Data;

	while ( 1 ) {
		if (  i >= kfir->microlen )
			break;
		if ( micro[ i ] == '#' ) {
			kfir->microp = micro+i+1;
			break;
		}
		if ( micro[ i ] == ' ' 
		     || micro[ i ] == '\t' 
		     || micro[ i ] == '\n' ) {
			i++;
			continue;
		}

		for ( Flag = false , Data = 0 ;  ; i++ ) {
			char c;
			
			if ( isxdigit( micro[ i ] ) ) {
				if ( micro[ i ] <= '9' 
				     && micro[ i ] >= '0' )
					c = micro[ i ] - '0';
				else {
					if ( micro[ i ] <= 'f' 
					     && micro[ i ] >= 'a' )
						c = micro[ i ] - 'a' + 10;
					else
						c = micro[ i ] - 'A' + 10;
				}
				Data = Data * 16 + c;
				Flag = TRUE;
			}
			else {
				if ( micro[ i ] != ' ' 
				     && micro[ i ] != '\r' 
				     && micro[i] != '\0' 
				     && micro[i] != '\n' )
					return -1;
				else
					break;
			}
		}
		if ( Flag == TRUE )
			ptMicroCode[ j++ ] = Data;
		//if (j<8) printk("%08x\n", ptMicroCode[j-1]);
	}
	
	*ptMicroCodeLength = j;
	printf("  0x%08x,",j);

	for (i=0; i<j; i++) {
	  if (!(i&3))
	    printf("\n  ");
	  printf("0x%08x, ", ptMicroCode[i]);
	}
	printf("\n\n");
	return 0;
}

main(int argc, char **argv)
{
  int fd;
  unsigned char *buf;
  DWORD *buf2;
  int len, mlen;
  struct kfir_dev kfir;

  buf=(unsigned char *) malloc(128000);
  buf2=(DWORD *) malloc(16384*4);

  fd=open(argv[1], O_RDONLY);

  kfir.microlen=len=read(fd, buf, 128000);
  kfir.micro=buf;
  kfir.microp=strchr((char *) buf, KF_MIC_DELIMETER)+1;

  printf("static u32 %s[] = {\n", argv[2]);
  Kfir_LoadMicroCode(&kfir, &mlen, buf2);
  Kfir_LoadMicroCode(&kfir, &mlen, buf2);
  Kfir_LoadMicroCode(&kfir, &mlen, buf2);
  Kfir_LoadMicroCode(&kfir, &mlen, buf2);
  Kfir_LoadMicroCode(&kfir, &mlen, buf2);
  Kfir_LoadMicroCode(&kfir, &mlen, buf2);
  printf("\n};\n", argv[2]);
  return 0;
}
